drew.fg.lib = function() {
  var lib = {};
  var urlvalid = new RegExp("^" + "(?:(?:https?|ftp)://)" + "(?:\\S+(?::\\S*)?@)?" + "(?:" + "(?!(?:10|127)(?:\\.\\d{1,3}){3})" + "(?!(?:169\\.254|192\\.168)(?:\\.\\d{1,3}){2})" + "(?!172\\.(?:1[6-9]|2\\d|3[0-1])(?:\\.\\d{1,3}){2})" + "(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])" + "(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}" + "(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))" + "|" + "(?:(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)" + "(?:\\.(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)*" + 
  "(?:\\.(?:[a-z\\u00a1-\\uffff]{2,}))" + ")" + "(?::\\d{2,5})?" + "(?:/\\S*)?" + "$", "i");
  var proxyvalid = new RegExp("^" + "(?:(?:https?|socks5|socks4|socks)://)" + "(?:\\S+(?::\\S*)?@)?" + "(?:" + "(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])" + "(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}" + "(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))" + "|" + "(?:(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)" + "(?:\\.(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)*" + "(?:\\.(?:[a-z\\u00a1-\\uffff]{2,}))" + ")" + "(?::\\d{2,5})" + "$", "i");
  lib.debug = function(level, mess) {
    if (level > drew.fg.conf.maxlevel) {
      if (typeof mess != "number" && typeof mess != "string") {
        mess = JSON.stringify(mess);
      }
      console.log(mess);
    }
    return true;
  };
  lib.proxyvalid = function(url) {
    if (!proxyvalid.test(url)) {
      return false;
    }
    return true;
  };
  lib.urlvalid = function(url) {
    if (!urlvalid.test(url)) {
      return false;
    }
    var purl = false;
    try {
      purl = new URL(url);
    } catch (e) {
      return false;
    }
    return purl;
  };
  lib.Array_contains = function(item, from) {
    return from.indexOf(item, from) != -1;
  };
  lib.host_contains = function(host, host_array) {
    var len = host_array.length;
    while (len--) {
      if (drew.fg.lib.shExpMatch(host, host_array[len])) {
        return true;
      }
    }
    return false;
  };
  lib.ReqJson = function(url, timeout, onSuccess, onError, onTimeout, type, data) {
    if (!type) {
      type = "GET";
    }
    if (!data) {
      data = null;
    }
    var xhr = new XMLHttpRequest;
    xhr.onabort = function() {
      onError("abort");
    };
    xhr.ontimeout = function() {
      onTimeout("onTimeout");
    };
    xhr.onerror = function() {
      onError(xhr.status + " " + xhr.statusText);
    };
    xhr.onload = function() {
      if (xhr.readyState === 4) {
        if (xhr.status === 200) {
          onSuccess(xhr.response);
        } else {
          onError(xhr.status);
        }
      }
    };
    try {
      xhr.open(type, url, true);
    } catch (e) {
      return;
    }
    if (type == "POST") {
      xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    }
    xhr.timeout = timeout;
    try {
      xhr.send(data);
    } catch (e$0) {
      return false;
    }
  };
  var rtrim = /^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g;
  lib.trim = function(str) {
    return str.replace(rtrim, "");
  };
  lib.clone = function(obj) {
    if (obj == null || typeof obj != "object") {
      return obj;
    }
    var temp = {};
    for (var key in obj) {
      temp[key] = lib.clone(obj[key]);
    }
    return temp;
  };
  lib.uniq = function(a) {
    return Array.from(new Set(a));
  };
  lib.uniq_obj = function(list) {
    var uniq = new Set(list.map(function(e) {
      return JSON.stringify(e);
    }));
    return Array.from(uniq).map(function(e) {
      return JSON.parse(e);
    });
  };
  lib.shExpMatch = function(url, pattern) {
    if ("*." + url == pattern) {
      return true;
    }
    var pCharCode;
    var isAggressive = false;
    var pIndex;
    var urlIndex = 0;
    var lastIndex;
    var patternLength = pattern.length;
    var urlLength = url.length;
    for (pIndex = 0; pIndex < patternLength; pIndex += 1) {
      pCharCode = pattern.charCodeAt(pIndex);
      if (pCharCode === 63) {
        if (isAggressive) {
          urlIndex += 1;
        }
        isAggressive = false;
        urlIndex += 1;
      } else {
        if (pCharCode === 42) {
          if (pIndex === patternLength - 1) {
            return urlIndex <= urlLength;
          } else {
            isAggressive = true;
          }
        } else {
          if (isAggressive) {
            lastIndex = urlIndex;
            urlIndex = url.indexOf(String.fromCharCode(pCharCode), lastIndex + 1);
            if (urlIndex < 0) {
              if (url.charCodeAt(lastIndex) !== pCharCode) {
                return false;
              }
              urlIndex = lastIndex;
            }
            isAggressive = false;
          } else {
            if (urlIndex >= urlLength || url.charCodeAt(urlIndex) !== pCharCode) {
              return false;
            }
          }
          urlIndex += 1;
        }
      }
    }
    return urlIndex === urlLength;
  };
  lib.parse_url = function(url) {
    var purl;
    try {
      purl = new URL(url);
    } catch (e) {
      return false;
    }
    return purl;
  };
  lib.create_host_wildcard = function(host) {
    var tmp_host_split = host.split(".");
    if (tmp_host_split[0].toLocaleLowerCase() === "www") {
      return "*." + host.substring(4);
    } else {
      return "*." + host;
    }
  };
  lib.shuffle = function(array) {
    var count = array.length, randomnumber, temp;
    while (count) {
      randomnumber = Math.random() * count-- | 0;
      temp = array[count];
      array[count] = array[randomnumber];
      array[randomnumber] = temp;
    }
  };
  return lib;
}();

