drew.fg.optlib = function() {
  var optlib = {};
  var hostvalid1 = /^[a-z0-9*][a-z0-9\-*.]{1,}[a-z0-9*]$/i;
  var hostvalid2 = /^[a-z0-9*][a-z0-9\-*.]+[a-z0-9*](\s+\[(\s*[a-z]{2}\s*,{0,1})+\])?$/i;
  var hostvalid3 = /\*{2,}/;
  optlib.l = function(mess, arg) {
    return chrome.i18n.getMessage(mess, arg);
  };
  optlib.close = function() {
    chrome.tabs.query({}, function(foundTabs) {
      var tabsCount = foundTabs.length;
      if (tabsCount === 1) {
        chrome.tabs.create({"url":"chrome://newtab"}, function(tab) {
          chrome.tabs.getCurrent(function(tab) {
            chrome.tabs.remove(tab.id, function() {
            });
          });
        });
      } else {
        chrome.tabs.getCurrent(function(tab) {
          chrome.tabs.remove(tab.id, function() {
          });
        });
      }
    });
  };
  optlib.dis_sites_input = function(arg) {
    arg.currentVal = $.trim(arg.currentVal);
    if (arg.currentVal === arg.oldVal) {
      return;
    }
    if (arg.start_sites !== arg.currentVal) {
      arg.sites_button.removeAttr("disabled");
    } else {
      arg.sites_button.prop("disabled", true);
    }
    return arg.currentVal;
  };
  optlib.ins_alert = function(container, type_alert, alert_text) {
    var ins = '<div class="uk-alert uk-alert-' + type_alert + '" data-uk-alert>' + '<a href="" class="uk-alert-close uk-close"></a>' + "<p>" + alert_text + "</p>" + "</div>";
    container.append(ins);
  };
  optlib.del_alert = function() {
    $(".uk-alert").remove();
  };
  optlib.show_err = function(errblock, button, textarea, list, string, i, txt) {
    var j;
    drew.fg.optlib.ins_alert(errblock, "danger", drew.fg.optlib.l("err_head1", [i + 1, txt]));
    if (button !== null) {
      button.prop("disabled", true);
      button.removeClass("uk-hidden");
    }
    var tmp_split_string = textarea.val().split(/\r?\n|\r/);
    var pos = 0;
    for (j = 0; j < i; j++) {
      pos = pos + tmp_split_string[j].length + 1;
    }
    textarea.selectRange(pos, pos + tmp_split_string[i].length);
  };
  optlib.site_parse = function(sites) {
    var ret = [];
    var j;
    while (j = sites.shift()) {
      if (!j.hasOwnProperty("h")) {
        continue;
      }
      var iteam = j.h;
      if (j.hasOwnProperty("co") && j.co.length > 0) {
        iteam = iteam + " [" + j.co.join() + "]";
      }
      if (j.hasOwnProperty("c") && j.c.length > 0) {
        iteam = iteam + "  //" + j.c + "";
      }
      ret.push(iteam);
    }
    return ret.join("\n");
  };
  optlib.proxy_parse = function(sites) {
    var ret = [];
    var j;
    while (j = sites.shift()) {
      if (!j.hasOwnProperty("h")) {
        continue;
      }
      var iteam = j.h;
      if (j.hasOwnProperty("co") && j.co.length > 0) {
        iteam = iteam + " [" + $.trim(j.co) + "]";
      }
      ret.push(iteam);
    }
    return ret.join("\n");
  };
  optlib.proxy_sites_button = function(arg) {
    arg.proxy_sites_button.addClass("uk-hidden");
    var co = [];
    var list = arg.en_proxy.val();
    var list_strings = $.trim(list).split("\n");
    var en_proxy_arr = [];
    drew.fg.optlib.del_alert();
    for (var i = 0; i < list_strings.length; i++) {
      var iteam = {};
      var str_split = list_strings[i].split(/\s+/g);
      if (str_split.length > 1) {
        var countres = str_split[1];
        if (countres.indexOf("[") == 0 && countres.indexOf("]") == countres.length - 1) {
          countres = countres.substring(1, countres.length - 1);
          var countres_split = countres.split(",");
          var j = undefined;
          while (j = countres_split.shift()) {
            j = $.trim(j);
            if (j.length == 2) {
              j = j.toUpperCase();
              iteam.co = j;
              co.push(j);
            }
          }
        }
      }
      var str_host = $.trim(str_split[0]);
      if (str_host == "") {
        continue;
      }
      if (drew.fg.lib.proxyvalid(str_host)) {
        iteam.h = str_host;
        en_proxy_arr.push(iteam);
      } else {
        drew.fg.optlib.show_err(arg.proxy_err, arg.proxy_sites_button, arg.en_proxy, list, str_host, i, drew.fg.optlib.l("mess_err_proxy"));
        return false;
      }
    }
    arg.proxy_sites_button.prop("disabled", true);
    drew.fg.ls.set("proxy", en_proxy_arr);
    drew.fg.ls.set("co", co);
    var start_en_proxy = "";
    if (en_proxy_arr.length > 0) {
      start_en_proxy = drew.fg.optlib.proxy_parse(en_proxy_arr);
      arg.en_proxy.val(start_en_proxy);
    } else {
      arg.en_proxy.val("");
    }
    chrome.runtime.getBackgroundPage(function(Window) {
      Window.drew.fg.core.onstartup();
      arg.proxy_sites_button.removeClass("uk-hidden");
      Window = null;
      if (arg.hasOwnProperty("calback")) {
        arg.calback();
      }
    });
    return start_en_proxy;
  };
  optlib.dis_sites_button = function(arg) {
    if (arg.dis_sites_button !== null) {
      arg.dis_sites_button.addClass("uk-hidden");
    }
    var list = arg.dis_sites.val();
    var list_strings = list.split("\n");
    var dis_sites_arr = [];
    drew.fg.optlib.del_alert();
    for (var i = 0; i < list_strings.length; i++) {
      var str_host = $.trim(list_strings[i]);
      if (str_host == "") {
        continue;
      }
      var find = str_host.indexOf("://");
      if (find > -1) {
        str_host = str_host.substring(find + 3);
      }
      var str_split = str_host.split(/\/+/g);
      str_host = str_split[0];
      if (hostvalid1.test(str_host) && !hostvalid3.test(str_host)) {
        dis_sites_arr.push(str_host);
      } else {
        drew.fg.optlib.show_err(arg.dis_err, arg.dis_sites_button, arg.dis_sites, list, str_host, i);
        return false;
      }
    }
    if (arg.dis_sites_button !== null) {
      arg.dis_sites_button.prop("disabled", true);
    }
    drew.fg.ls.set("sites_exception", dis_sites_arr);
    var start_dis_sites = "";
    if (dis_sites_arr.length > 0) {
      start_dis_sites = dis_sites_arr.join("\n");
      arg.dis_sites.val(start_dis_sites);
    } else {
      arg.dis_sites.val("");
    }
    chrome.runtime.getBackgroundPage(function(Window) {
      Window.drew.fg.core.onstartup();
      if (arg.dis_sites_button !== null) {
        arg.dis_sites_button.removeClass("uk-hidden");
      }
      Window = null;
    });
    return start_dis_sites;
  };
  optlib.en_sites_button = function(arg) {
    if (arg.en_sites_button !== null) {
      arg.en_sites_button.addClass("uk-hidden");
    }
    var list = arg.en_sites.val();
    var list_strings = list.split("\n");
    var en_sites_arr = [];
    var all_sites_arr = [];
    drew.fg.optlib.del_alert();
    for (var i = 0; i < list_strings.length; i++) {
      if (!$.trim(list_strings[i])) {
        continue;
      }
      var iteam = {};
      var list_string = $.trim(list_strings[i]);
      var tmp_string_split = list_string.split("://");
      if (tmp_string_split.length > 1) {
        list_string = tmp_string_split[1];
      } else {
        list_string = tmp_string_split[0];
      }
      tmp_string_split = list_string.split("//");
      if (tmp_string_split.length > 1) {
        iteam.c = tmp_string_split[1];
      }
      list_string = $.trim(tmp_string_split[0]);
      tmp_string_split = list_string.split("/");
      list_string = tmp_string_split[0];
      if (!hostvalid2.test(list_string) || hostvalid3.test(list_string)) {
        drew.fg.optlib.show_err(arg.en_err, arg.en_sites_button, arg.en_sites, list, list_strings[i], i, drew.fg.optlib.l("mess_err_domain"));
        return false;
      }
      var str_split = list_string.split(/\s+/g);
      if (str_split.length > 1) {
        var countres = str_split[1];
        if (countres.indexOf("[") == 0 && countres.indexOf("]") == countres.length - 1) {
          countres = countres.substring(1, countres.length - 1);
          var countres_split = countres.split(",");
          var j = undefined;
          while (j = countres_split.shift()) {
            if (j.length == 2) {
              j = j.toUpperCase();
              if (!iteam.hasOwnProperty("co")) {
                iteam.co = [];
              }
              iteam.co.push(j);
            }
          }
        }
      }
      var str_host = str_split[0];
      str_host = $.trim(str_host);
      if (str_host == "") {
        continue;
      }
      var find = str_host.indexOf("://");
      if (find > -1) {
        str_host = str_host.substring(find + 3);
      }
      var host_split = str_host.split(/\/+/g);
      str_host = host_split[0];
      if (hostvalid1.test(str_host)) {
        iteam.h = str_host;
        if (drew.fg.lib.Array_contains(str_host, all_sites_arr)) {
          drew.fg.optlib.show_err(arg.en_err, arg.en_sites_button, arg.en_sites, list, list_strings[i], i, drew.fg.optlib.l("mess_err_duplicate"));
          return false;
        } else {
          all_sites_arr.push(str_host);
          en_sites_arr.push(iteam);
        }
      } else {
        drew.fg.optlib.show_err(arg.en_err, arg.en_sites_button, arg.en_sites, list, list_strings[i], i, drew.fg.optlib.l("mess_err_domain"));
        return false;
      }
    }
    if (arg.en_sites_button !== null) {
      arg.en_sites_button.prop("disabled", true);
    }
    drew.fg.ls.set("sites", en_sites_arr);
    var start_en_sites = "";
    if (en_sites_arr.length > 0) {
      start_en_sites = drew.fg.optlib.site_parse(en_sites_arr);
      arg.en_sites.val(start_en_sites);
    } else {
      arg.en_sites.val("");
    }
    chrome.runtime.getBackgroundPage(function(Window) {
      Window.drew.fg.core.onstartup();
      if (arg.en_sites_button !== null) {
        arg.en_sites_button.removeClass("uk-hidden");
      }
      Window = null;
    });
    return start_en_sites;
  };
  return optlib;
}();

